﻿/*
 * This file is part of SCWS.
 * SCWS is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with SCWS.  If not, see <http://www.gnu.org/licenses/>.
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;

namespace Scws
{
    public partial class Om :System.Web.Services.WebService
    {
        /// <summary>
        /// Exception for when finding too many/too few objects
        /// </summary>
        [Serializable]
        public class TooManyObjectsFoundException : Exception
        {
            // Use the default ApplicationException constructors
            public TooManyObjectsFoundException() : base() { }
            public TooManyObjectsFoundException(string s) : base(s) { }
            public TooManyObjectsFoundException(string s, Exception ex)
                : base(s, ex) { }
        }

        /// <summary>
        /// XSD Schema file not found
        /// </summary>
        [Serializable]
        public class XsdNotFoundException : Exception
        {
            // Use the default ApplicationException constructors
            public XsdNotFoundException() : base() { }
            public XsdNotFoundException(string s) : base(s) { }
            public XsdNotFoundException(string s, Exception ex)
                : base(s, ex) { }
        }
    }
}
